<script setup lang="ts">
import { nextTick, onMounted, ref } from 'vue'
import type { Product } from '@/types/Product'
import { useProductsStore } from '@/stores/product'
import type { VForm } from 'vuetify/components'

const headers = [
  {
    title: 'Id',
    key: 'id'
  },
  {
    title: 'Name',
    key: 'name'
  },
  {
    title: 'Price',
    key: 'price'
  },
  { title: 'Actions', key: 'actions', sortable: false }
]

const productsStore = useProductsStore()

let editedIndex = -1
const editedProducts = ref<Product>(JSON.parse(JSON.stringify(productsStore.defaultProducts)))
const products = ref<Product[]>([])

const dialog = ref(false)
const dialogDelete = ref(false)
const form = ref(false)
const loading = ref(false)
const refForm = ref<VForm | null>(null)
let lastestId = productsStore.LastID() + 1
const initilUser: Product = {
  id: -1,
  name: '',
  price: 0,
  type: 0
}

function editItem(item: Product) {
  editedProducts.value = Object.assign({}, item)
  dialog.value = true
}

function deleteItem(item: Product) {
  editedProducts.value = Object.assign({}, item)
  dialogDelete.value = true
  editedIndex = -1
}

function deleteItemConfirm() {
  // Delete item from list
  closeDelete()
  productsStore.deleteUser(editedProducts.value)
}

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    editedProducts.value = Object.assign({}, initilUser)
  })
}

function onSubmit() {}

function closeDialog() {
  dialog.value = false
  nextTick(() => {
    editedProducts.value = Object.assign({}, initilUser)
    editedIndex = -1
  })
}

async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return

  closeDialog()
  await productsStore.saveProduct(editedProducts.value)
}

onMounted(() => {
  productsStore.getProducts()
})
</script>

<template>
  <div>
    <v-data-table
      :headers="headers"
      :items="products"
      style="background-color: white; color: black"
      height="664"
    >
      <template v-slot:top>
        <v-toolbar flat style="background-color: #282828; color: white">
          <v-toolbar-title>Product 1</v-toolbar-title>
          <v-dialog v-model="dialog" persistent width="500">
            <template v-slot:activator="{ props }">
              <v-btn v-bind="props" style="background-color: #c7a17a" color="white">
                New Product
              </v-btn>
            </template>
            <v-card>
              <v-card-title>
                <span class="text-h5">Product 1</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refform" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="12" md="12">
                        <v-text-field
                          v-model="editedProducts.name"
                          :readonly="loading"
                          :rules="[(v) => !!v || '*indicates required field']"
                          clearable
                          label="Product Name"
                          placeholder="Enter Product Name"
                        ></v-text-field>
                      </v-col>

                      <v-col cols="12" sm="12" md="12">
                        <v-text-field
                          v-model="editedProducts.price"
                          :readonly="loading"
                          :rules="[(v) => !!v || '*indicates required field']"
                          class="mb-2"
                          clearable
                          label="Total Price"
                        ></v-text-field>
                      </v-col>
                    </v-row>
                  </v-container>
                </v-form>
                <small style="color: red">*indicates required field</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDialog()"> Close </v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>
      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" class="me-2" v-model="dialog" @click="editItem(item)">
          mdi-pencil
        </v-icon>
        <v-icon size="small" v-model="dialogDelete" @click="deleteItem(item)"> mdi-delete </v-icon>
      </template>
    </v-data-table>
  </div>

  <v-dialog v-model="dialogDelete" width="500px">
    <v-card>
      <br />
      <v-img style="margin-left: 230px" :width="40" src="\src\assets\Login\icon.png"></v-img>
      <v-spacer></v-spacer>
      <v-card-title align="center" class="text-h5">Are you sure?</v-card-title>
      <v-card-title align="center" class="text-h10">
        This action cannot be undone.<br />
        All values associated with this field will be lost.
      </v-card-title>
      <v-spacer></v-spacer>
      <div align="center">
        <div style="margin: 0 auto; max-width: 400px">
          <v-btn
            block
            style="background-color: #e11d48"
            color="white"
            variant="text"
            @click="deleteItemConfirm()"
          >
            Delete field
          </v-btn>
        </div>
      </div>
      <div align="center">
        <div
          style="
            margin: 0 auto;
            max-width: 400px;
            border: 1px solid #dfe1e6;
            border-radius: 5px;
            margin-top: 10px;
          "
        >
          <v-btn block color="primary" variant="text" @click="closeDelete()"> Cancel </v-btn>
        </div>
      </div>
      <v-spacer></v-spacer>
      <br />
    </v-card>
  </v-dialog>
</template>

<style scoped></style>
